#!/bin/bash
#Author: Yanqing Su
#Date:09/10/2019
############################################################################## 

O_WORKDIR=$(pwd)
DATA_DIR="/home/yanqing/data/CPFFT/Mg_para_twinembryo_45_s_c3_6/"
mkdir -p ${DATA_DIR}
cd ${DATA_DIR}
cp ${O_WORKDIR}/run_all.sh .
coef=(0.5 1 2 3 5 8)
twinthick=(6 6 6 6 6 6)
ph=0
th=90
om=0

for i in `seq 0 5`
do
  dir=${coef[$i]}_${twinthick[$i]}
  mkdir -p $dir
  cd $dir

  cp ${O_WORKDIR}/fft.in .
  cp ${O_WORKDIR}/*.sx .
  cp ${O_WORKDIR}/*.py .
  cp ${O_WORKDIR}/*.f90 .
  cp ${O_WORKDIR}/*.pbs .
  ./construct_TwoParaEmbryos.py 3 510 510 ${coef[$i]} ${twinthick[$i]} $ph $th $om 25 in 
  gfortran -L $Home/usr/lib -lfftw3 Tricrystals.f90 -o Tricrystals.out 

  cd ..
#module load intel/18
#cat $PBS_NODEFILE > nodes
done

sh run_all.sh
