#!/bin/bash
#Author: Yanqing Su
#Date:09/10/2019
############################################################################## 

O_WORKDIR=$(pwd)
DATA_DIR="/home/yanqing/data/CPFFT/Mg_single_twinembryo_c3/"
mkdir -p ${DATA_DIR}
cd ${DATA_DIR}
cp ${O_WORKDIR}/run_all.sh .
coef=1
twinthick=(4 6 8 12 16 24)
ph=0
th=90
om=0

for i in `seq 0 5`
do
  dir=${coef}_${twinthick[$i]}
  mkdir -p $dir
  cd $dir

  cp ${O_WORKDIR}/fft.in .
  cp ${O_WORKDIR}/*.sx .
  cp ${O_WORKDIR}/*.py .
  cp ${O_WORKDIR}/*.f90 .
  cp ${O_WORKDIR}/*.pbs .
  ./construct_embryo_single.py 3 510 510 ${coef} ${twinthick[$i]} $ph $th $om 25 in 
  gfortran -L $Home/usr/lib -lfftw3 localeigen_bleu_MgX.f90 -o localeigen_bleu_MgX.out 

  cd ..
#module load intel/18
#cat $PBS_NODEFILE > nodes
done

sh run_all.sh
